import { world, system, PlayerInteractWithEntityBeforeEventSignal } from "@minecraft/server";

world.afterEvents.entityHitEntity.subscribe((eventData) => {
    const hitEntity = eventData.hitEntity;
    const damagingEntity = eventData.damagingEntity;
    if(damagingEntity.typeId == "minecraft:player" && hitEntity.typeId == "tt:jehol_book"){
        const angle = AngleOperation(damagingEntity.location.x, damagingEntity.location.z, hitEntity.location.x, hitEntity.location.z);
        const yaw = damagingEntity.getRotation().y;
        if(angle > (yaw + 180)){
            hitEntity.triggerEvent("left");
        } else {
            hitEntity.triggerEvent("right");
        }
    }
});

function AngleOperation(x1, z1, x2, z2){
    const x = x2 - x1;
    const y = -(z2 - z1);

    const distance = Math.sqrt(x*x + y*y);
    if(distance == 0){
        return 0
    } else {
        var targetAngle = Math.asin(y / distance) / Math.PI * 180;
        if(x >= 0){
            targetAngle = 90 - targetAngle;
        }else if(x <= 0){
            targetAngle = 270 + targetAngle;
        }
        return targetAngle;
    }
}